create table organization_registration(
    org_id_php int not null,
    org_id_rest int default -1,
    referral_code varchar(64) not null,
    primary key (org_id_php, org_id_rest, referral_code)
);

INSERT INTO organization_registration (org_id_php, referral_code) VALUES (3, 'abc');

create table scholarship_acceptance(
    user_id_student int not null,
    user_id_scholarship_php int not null,
    scholarship_id_php int not null,
    scholarship_id_rest int not null,
    status enum('accepted', 'rejected', 'waiting'),
    primary key (user_id_student, user_id_scholarship_php, scholarship_id_php, scholarship_id_rest)
);

create table scholarship(
    user_id_scholarship_php int not null,
    scholarship_id_php int not null,
    user_id_scholarship_rest int not null,
    scholarship_id_rest int default -1,
    view_count int default 0,
    primary key(user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest, scholarship_id_rest)
);

create table university(
    rest_uni_id int not null,
    php_uni_id int default -1,
    name varchar(255),
    primary key (rest_uni_id, php_uni_id)
);

create table students(
    user_id int not null,
    rest_uni_id int not null,
    php_uni_id int not null,
    primary key (user_id, rest_uni_id, php_uni_id),
    foreign key (rest_uni_id) references university(rest_uni_id)
);

create table logging(
    logging_id int not null auto_increment,
    endpoint varchar(255) not null,
    description varchar(255) not null,
    ip_address varchar(16) not null,
    timestamp TIMESTAMP not null default CURRENT_TIMESTAMP,
    primary key (logging_id)
);

create table apikeys(
    id_key int not null auto_increment,
    service_name varchar(255) not null,
    key_value varchar(255) not null,
    primary key (id_key, key_value)
);

insert into apikeys(service_name, key_value) values ("PHP", "kunciT"), ("REST", "shortT_Key");


INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 4, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 5, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 6, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 7, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 8, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 9, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 10, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 11, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 12, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 13, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 14, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 15, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 16, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 17, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 18, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 19, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 20, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 21, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 22, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 23, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 24, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 25, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 26, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 27, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 28, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 29, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 30, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 31, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 32, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 33, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 34, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 35, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 36, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 37, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 38, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 39, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 40, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 41, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 42, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 43, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 44, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 45, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 46, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 47, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 48, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 49, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 50, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 51, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 52, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 53, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 54, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 55, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 56, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 57, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 58, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 59, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 60, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 61, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 62, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 63, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 64, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 65, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 66, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 67, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 68, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 69, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 70, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 71, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 72, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 73, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 74, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 75, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 76, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 77, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 78, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 79, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 80, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 81, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 82, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 83, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 84, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 85, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 86, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 87, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 88, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 89, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 90, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 91, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 92, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 93, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 94, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 95, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 96, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 97, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 98, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 99, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 100, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 101, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 102, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 103, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 104, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 105, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 106, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 107, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 108, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 109, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 110, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 111, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 112, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 113, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 114, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 115, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 116, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 117, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 118, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 119, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 120, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 121, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 122, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 123, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 124, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 125, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 126, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 127, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 128, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 129, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 130, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 131, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 132, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 133, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 134, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 135, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 136, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 137, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 138, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 139, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 140, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 141, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 142, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 143, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 144, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 145, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 146, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 147, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 148, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 149, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 150, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 151, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 152, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 153, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 154, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 155, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 156, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 157, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 158, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 159, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 160, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 161, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 162, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 163, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 164, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 165, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 166, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 167, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 168, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 169, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 170, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 171, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 172, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 173, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 174, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 175, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 176, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 177, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 178, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 179, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 180, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 181, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 182, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 183, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 184, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 185, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 186, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 187, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 188, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 189, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 190, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 191, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 192, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 193, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 194, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 195, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 196, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 197, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 198, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 199, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 200, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 201, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 202, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 203, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 204, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 205, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 206, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 207, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 208, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 209, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 210, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 211, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 212, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 213, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 214, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 215, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 216, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 217, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 218, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 219, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 220, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 221, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 222, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 223, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 224, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 225, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 226, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 227, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 228, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 229, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 230, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 231, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 232, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 233, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 234, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 235, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 236, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 237, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 238, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 239, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 240, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 241, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 242, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 243, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 244, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 245, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 246, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 247, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 248, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 249, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 250, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 251, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 252, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 253, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 254, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 255, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 256, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 257, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 258, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 259, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 260, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 261, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 262, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 263, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 264, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 265, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 266, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 267, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 268, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 269, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 270, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 271, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 272, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 273, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 274, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 275, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 276, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 277, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 278, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 279, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 280, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 281, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 282, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 283, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 284, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 285, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 286, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 287, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 288, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 289, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 290, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 291, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 292, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 293, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 294, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 295, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 296, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 297, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 298, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 299, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 300, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 301, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 302, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 303, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 304, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 305, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 306, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 307, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 308, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 309, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 310, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 311, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 312, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 313, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 314, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 315, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 316, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 317, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 318, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 319, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 320, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 321, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 322, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 323, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 324, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 325, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 326, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 327, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 328, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 329, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 330, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 331, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 332, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 333, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 334, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 335, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 336, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 337, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 338, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 339, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 340, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 341, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 342, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 343, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 344, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 345, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 346, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 347, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 348, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 349, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 350, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 351, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 352, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 353, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 354, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 355, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 356, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 357, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 358, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 359, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 360, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 361, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 362, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 363, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 364, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 365, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 366, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 367, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 368, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 369, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 370, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 371, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 372, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 373, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 374, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 375, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 376, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 377, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 378, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 379, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 380, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 381, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 382, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 383, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 384, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 385, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 386, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 387, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 388, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 389, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 390, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 391, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 392, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 393, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 394, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 395, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 396, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 397, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 398, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 399, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 400, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 401, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 402, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 403, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 404, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 405, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 406, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 407, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 408, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 409, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 410, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 411, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 412, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 413, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 414, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 415, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 416, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 417, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 418, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 419, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 420, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 421, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 422, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 423, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 424, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 425, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 426, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 427, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 428, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 429, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 430, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 431, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 432, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 433, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 434, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 435, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 436, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 437, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 438, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 439, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 440, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 441, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 442, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 443, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 444, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 445, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 446, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 447, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 448, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 449, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 450, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 451, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 452, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 453, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 454, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 455, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 456, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 457, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 458, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 459, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 460, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 461, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 462, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 463, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 464, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 465, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 466, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 467, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 468, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 469, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 470, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 471, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 472, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 473, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 474, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 475, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 476, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 477, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 478, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 479, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 480, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 481, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 482, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 483, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 484, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 485, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 486, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 487, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 488, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 489, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 490, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 491, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 492, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 493, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 494, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 495, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 496, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 497, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 498, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 499, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 500, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 501, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 502, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 503, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 504, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 505, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 506, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 507, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 508, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 509, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 510, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 511, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 512, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 513, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 514, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 515, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 516, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 517, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 518, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 519, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 520, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 521, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 522, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 523, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 524, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 525, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 526, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 527, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 528, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 529, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 530, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 531, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 532, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 533, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 534, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 535, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 536, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 537, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 538, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 539, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 540, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 541, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 542, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 543, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 544, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 545, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 546, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 547, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 548, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 549, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 550, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 551, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 552, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 553, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 554, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 555, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 556, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 557, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 558, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 559, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 560, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 561, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 562, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 563, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 564, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 565, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 566, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 567, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 568, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 569, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 570, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 571, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 572, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 573, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 574, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 575, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 576, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 577, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 578, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 579, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 580, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 581, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 582, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 583, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 584, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 585, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 586, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 587, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 588, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 589, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 590, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 591, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 592, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 593, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 594, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 595, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 596, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 597, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 598, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 599, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 600, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 601, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 602, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 603, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 604, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 605, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 606, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 607, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 608, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 609, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 610, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 611, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 612, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 613, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 614, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 615, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 616, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 617, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 618, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 619, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 620, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 621, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 622, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 623, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 624, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 625, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 626, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 627, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 628, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 629, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 630, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 631, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 632, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 633, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 634, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 635, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 636, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 637, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 638, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 639, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 640, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 641, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 642, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 643, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 644, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 645, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 646, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 647, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 648, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 649, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 650, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 651, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 652, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 653, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 654, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 655, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 656, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 657, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 658, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 659, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 660, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 661, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 662, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 663, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 664, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 665, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 666, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 667, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 668, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 669, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 670, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 671, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 672, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 673, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 674, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 675, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 676, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 677, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 678, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 679, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 680, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 681, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 682, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 683, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 684, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 685, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 686, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 687, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 688, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 689, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 690, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 691, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 692, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 693, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 694, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 695, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 696, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 697, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 698, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 699, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 700, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 701, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 702, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 703, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 704, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 705, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 706, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 707, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 708, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 709, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 710, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 711, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 712, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 713, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 714, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 715, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 716, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 717, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 718, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 719, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 720, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 721, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 722, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 723, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 724, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 725, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 726, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 727, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 728, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 729, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 730, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 731, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 732, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 733, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 734, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 735, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 736, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 737, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 738, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 739, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 740, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 741, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 742, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 743, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 744, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 745, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 746, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 747, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 748, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 749, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 750, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 751, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 752, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 753, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 754, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 755, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 756, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 757, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 758, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 759, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 760, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 761, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 762, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 763, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 764, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 765, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 766, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 767, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 768, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 769, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 770, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 771, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 772, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 773, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 774, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 775, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 776, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 777, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 778, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 779, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 780, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 781, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 782, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 783, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 784, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 785, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 786, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 787, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 788, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 789, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 790, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 791, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 792, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 793, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 794, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 795, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 796, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 797, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 798, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 799, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 800, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 801, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 802, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 803, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 804, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 805, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 806, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 807, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 808, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 809, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 810, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 811, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 812, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 813, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 814, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 815, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 816, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 817, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 818, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 819, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 820, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 821, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 822, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 823, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 824, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 825, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 826, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 827, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 828, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 829, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 830, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 831, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 832, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 833, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 834, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 835, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 836, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 837, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 838, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 839, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 840, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 841, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 842, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 843, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 844, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 845, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 846, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 847, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 848, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 849, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 850, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 851, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 852, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 853, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 854, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 855, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 856, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 857, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 858, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 859, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 860, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 861, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 862, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 863, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 864, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 865, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 866, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 867, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 868, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 869, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 870, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 871, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 872, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 873, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 874, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 875, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 876, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 877, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 878, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 879, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 880, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 881, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 882, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 883, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 884, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 885, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 886, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 887, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 888, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 889, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 890, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 891, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 892, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 893, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 894, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 895, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 896, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 897, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 898, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 899, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 900, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 901, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 902, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 903, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 904, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 905, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 906, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 907, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 908, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 909, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 910, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 911, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 912, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 913, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 914, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 915, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 916, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 917, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 918, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 919, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 920, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 921, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 922, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 923, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 924, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 925, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 926, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 927, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 928, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 929, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 930, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 931, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 932, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 933, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 934, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 935, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 936, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 937, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 938, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 939, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 940, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 941, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 942, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 943, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 944, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 945, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 946, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 947, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 948, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 949, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 950, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 951, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 952, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 953, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 954, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 955, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 956, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 957, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 958, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 959, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 960, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 961, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 962, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 963, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 964, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 965, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 966, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 967, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 968, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 969, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 970, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 971, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 972, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 973, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 974, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 975, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 976, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 977, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 978, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 979, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 980, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 981, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 982, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 983, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 984, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 985, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 986, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 987, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 988, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 989, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 990, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 991, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 992, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 993, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 994, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 995, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 996, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 997, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 998, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 999, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1000, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1001, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1002, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1003, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1004, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1005, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1006, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1007, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1008, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1009, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1010, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1011, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1012, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1013, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1014, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1015, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1016, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1017, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1018, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1019, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1020, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1021, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1022, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1023, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1024, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1025, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1026, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1027, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1028, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1029, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1030, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1031, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1032, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1033, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1034, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1035, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1036, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1037, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1038, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1039, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1040, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1041, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1042, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1043, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1044, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1045, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1046, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1047, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1048, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1049, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1050, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1051, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1052, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1053, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1054, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1055, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1056, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1057, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1058, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1059, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1060, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1061, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1062, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1063, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1064, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1065, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1066, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1067, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1068, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1069, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1070, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1071, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1072, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1073, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1074, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1075, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1076, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1077, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1078, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1079, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1080, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1081, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1082, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1083, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1084, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1085, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1086, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1087, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1088, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1089, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1090, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1091, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1092, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1093, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1094, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1095, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1096, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1097, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1098, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1099, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1100, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1101, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1102, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1103, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1104, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1105, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1106, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1107, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1108, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1109, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1110, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1111, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1112, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1113, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1114, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1115, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1116, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1117, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1118, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1119, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1120, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1121, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1122, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1123, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1124, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1125, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1126, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1127, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1128, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1129, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1130, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1131, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1132, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1133, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1134, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1135, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1136, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1137, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1138, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1139, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1140, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1141, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1142, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1143, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1144, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1145, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1146, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1147, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1148, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1149, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1150, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1151, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1152, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1153, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1154, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1155, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1156, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1157, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1158, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1159, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1160, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1161, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1162, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1163, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1164, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1165, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1166, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1167, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1168, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1169, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1170, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1171, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1172, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1173, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1174, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1175, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1176, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1177, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1178, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1179, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1180, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1181, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1182, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1183, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1184, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1185, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1186, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1187, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1188, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1189, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1190, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1191, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1192, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1193, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1194, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1195, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1196, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1197, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1198, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1199, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1200, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1201, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1202, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1203, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1204, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1205, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1206, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1207, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1208, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1209, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1210, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1211, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1212, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1213, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1214, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1215, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1216, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1217, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1218, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1219, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1220, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1221, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1222, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1223, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1224, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1225, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1226, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1227, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1228, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1229, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1230, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1231, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1232, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1233, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1234, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1235, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1236, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1237, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1238, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1239, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1240, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1241, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1242, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1243, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1244, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1245, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1246, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1247, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1248, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1249, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1250, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1251, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1252, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1253, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1254, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1255, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1256, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1257, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1258, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1259, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1260, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1261, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1262, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1263, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1264, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1265, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1266, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1267, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1268, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1269, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1270, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1271, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1272, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1273, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1274, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1275, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1276, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1277, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1278, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1279, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1280, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1281, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1282, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1283, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1284, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1285, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1286, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1287, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1288, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1289, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1290, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1291, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1292, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1293, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1294, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1295, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1296, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1297, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1298, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1299, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1300, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1301, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1302, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1303, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1304, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1305, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1306, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1307, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1308, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1309, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1310, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1311, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1312, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1313, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1314, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1315, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1316, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1317, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1318, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1319, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1320, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1321, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1322, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1323, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1324, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1325, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1326, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1327, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1328, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1329, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1330, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1331, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1332, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1333, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1334, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1335, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1336, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1337, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1338, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1339, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1340, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1341, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1342, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1343, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1344, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1345, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1346, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1347, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1348, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1349, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1350, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1351, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1352, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1353, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1354, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1355, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1356, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1357, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1358, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1359, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1360, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1361, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1362, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1363, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1364, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1365, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1366, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1367, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1368, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1369, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1370, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1371, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1372, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1373, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1374, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1375, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1376, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1377, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1378, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1379, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1380, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1381, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1382, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1383, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1384, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1385, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1386, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1387, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1388, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1389, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1390, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1391, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1392, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1393, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1394, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1395, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1396, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1397, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1398, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1399, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1400, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1401, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1402, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1403, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1404, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1405, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1406, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1407, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1408, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1409, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1410, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1411, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1412, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1413, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1414, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1415, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1416, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1417, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1418, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1419, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1420, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1421, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1422, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1423, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1424, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1425, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1426, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1427, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1428, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1429, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1430, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1431, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1432, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1433, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1434, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1435, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1436, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1437, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1438, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1439, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1440, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1441, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1442, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1443, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1444, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1445, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1446, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1447, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1448, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1449, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1450, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1451, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1452, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1453, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1454, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1455, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1456, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1457, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1458, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1459, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1460, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1461, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1462, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1463, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1464, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1465, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1466, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1467, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1468, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1469, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1470, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1471, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1472, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1473, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1474, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1475, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1476, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1477, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1478, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1479, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1480, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1481, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1482, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1483, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1484, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1485, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1486, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1487, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1488, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1489, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1490, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1491, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1492, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1493, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1494, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1495, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1496, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1497, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1498, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1499, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1500, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1501, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1502, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1503, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1504, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1505, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1506, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1507, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1508, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1509, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1510, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1511, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1512, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1513, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1514, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1515, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1516, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1517, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1518, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1519, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1520, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1521, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1522, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1523, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1524, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1525, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1526, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1527, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1528, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1529, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1530, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1531, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1532, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1533, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1534, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1535, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1536, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1537, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1538, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1539, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1540, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1541, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1542, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1543, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1544, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1545, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1546, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1547, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1548, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1549, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1550, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1551, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1552, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1553, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1554, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1555, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1556, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1557, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1558, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1559, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1560, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1561, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1562, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1563, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1564, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1565, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1566, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1567, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1568, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1569, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1570, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1571, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1572, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1573, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1574, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1575, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1576, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1577, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1578, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1579, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1580, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1581, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1582, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1583, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1584, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1585, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1586, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1587, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1588, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1589, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1590, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1591, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1592, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1593, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1594, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1595, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1596, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1597, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1598, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1599, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1600, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1601, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1602, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1603, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1604, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1605, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1606, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1607, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1608, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1609, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1610, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1611, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1612, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1613, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1614, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1615, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1616, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1617, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1618, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1619, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1620, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1621, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1622, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1623, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1624, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1625, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1626, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1627, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1628, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1629, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1630, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1631, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1632, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1633, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1634, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1635, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1636, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1637, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1638, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1639, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1640, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1641, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1642, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1643, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1644, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1645, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1646, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1647, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1648, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1649, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1650, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1651, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1652, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1653, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1654, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1655, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1656, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1657, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1658, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1659, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1660, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1661, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1662, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1663, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1664, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1665, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1666, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1667, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1668, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1669, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1670, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1671, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1672, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1673, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1674, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1675, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1676, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1677, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1678, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1679, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1680, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1681, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1682, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1683, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1684, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1685, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1686, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1687, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1688, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1689, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1690, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1691, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1692, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1693, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1694, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1695, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1696, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1697, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1698, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1699, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1700, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1701, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1702, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1703, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1704, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1705, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1706, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1707, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1708, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1709, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1710, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1711, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1712, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1713, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1714, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1715, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1716, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1717, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1718, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1719, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1720, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1721, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1722, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1723, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1724, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1725, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1726, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1727, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1728, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1729, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1730, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1731, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1732, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1733, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1734, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1735, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1736, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1737, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1738, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1739, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1740, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1741, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1742, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1743, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1744, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1745, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1746, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1747, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1748, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1749, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1750, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1751, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1752, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1753, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1754, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1755, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1756, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1757, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1758, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1759, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1760, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1761, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1762, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1763, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1764, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1765, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1766, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1767, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1768, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1769, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1770, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1771, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1772, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1773, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1774, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1775, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1776, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1777, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1778, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1779, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1780, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1781, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1782, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1783, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1784, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1785, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1786, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1787, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1788, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1789, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1790, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1791, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1792, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1793, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1794, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1795, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1796, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1797, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1798, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1799, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1800, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1801, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1802, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1803, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1804, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1805, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1806, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1807, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1808, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1809, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1810, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1811, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1812, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1813, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1814, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1815, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1816, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1817, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1818, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1819, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1820, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1821, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1822, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1823, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1824, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1825, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1826, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1827, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1828, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1829, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1830, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1831, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1832, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1833, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1834, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1835, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1836, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1837, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1838, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1839, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1840, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1841, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1842, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1843, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1844, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1845, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1846, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1847, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1848, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1849, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1850, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1851, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1852, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1853, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1854, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1855, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1856, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1857, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1858, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1859, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1860, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1861, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1862, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1863, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1864, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1865, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1866, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1867, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1868, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1869, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1870, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1871, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1872, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1873, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1874, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1875, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1876, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1877, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1878, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1879, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1880, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1881, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1882, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1883, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1884, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1885, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1886, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1887, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1888, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1889, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1890, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1891, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1892, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1893, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1894, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1895, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1896, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1897, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1898, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1899, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1900, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1901, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1902, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1903, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1904, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1905, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1906, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1907, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1908, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1909, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1910, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1911, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1912, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1913, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1914, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1915, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1916, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1917, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1918, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1919, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1920, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1921, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1922, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1923, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1924, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1925, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1926, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1927, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1928, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1929, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1930, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1931, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1932, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1933, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1934, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1935, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1936, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1937, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1938, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1939, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1940, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1941, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1942, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1943, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1944, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1945, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1946, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1947, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1948, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1949, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1950, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1951, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1952, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1953, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1954, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1955, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1956, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1957, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1958, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1959, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1960, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1961, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1962, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1963, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1964, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1965, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1966, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1967, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1968, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1969, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1970, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1971, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1972, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1973, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1974, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1975, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1976, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1977, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1978, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1979, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1980, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1981, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1982, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1983, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1984, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1985, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1986, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1987, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1988, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1989, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1990, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1991, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1992, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1993, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1994, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1995, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1996, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1997, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1998, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 1999, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2000, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2001, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2002, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2003, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2004, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2005, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2006, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2007, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2008, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2009, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2010, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2011, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2012, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2013, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2014, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2015, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2016, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2017, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2018, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2019, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2020, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2021, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2022, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2023, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2024, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2025, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2026, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2027, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2028, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2029, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2030, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2031, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2032, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2033, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2034, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2035, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2036, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2037, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2038, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2039, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2040, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2041, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2042, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2043, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2044, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2045, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2046, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2047, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2048, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2049, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2050, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2051, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2052, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2053, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2054, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2055, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2056, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2057, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2058, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2059, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2060, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2061, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2062, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2063, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2064, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2065, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2066, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2067, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2068, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2069, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2070, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2071, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2072, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2073, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2074, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2075, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2076, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2077, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2078, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2079, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2080, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2081, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2082, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2083, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2084, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2085, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2086, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2087, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2088, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2089, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2090, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2091, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2092, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2093, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2094, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2095, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2096, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2097, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2098, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2099, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2100, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2101, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2102, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2103, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2104, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2105, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2106, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2107, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2108, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2109, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2110, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2111, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2112, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2113, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2114, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2115, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2116, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2117, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2118, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2119, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2120, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2121, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2122, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2123, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2124, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2125, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2126, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2127, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2128, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2129, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2130, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2131, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2132, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2133, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2134, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2135, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2136, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2137, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2138, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2139, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2140, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2141, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2142, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2143, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2144, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2145, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2146, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2147, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2148, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2149, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2150, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2151, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2152, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2153, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2154, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2155, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2156, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2157, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2158, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2159, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2160, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2161, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2162, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2163, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2164, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2165, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2166, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2167, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2168, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2169, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2170, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2171, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2172, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2173, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2174, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2175, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2176, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2177, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2178, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2179, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2180, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2181, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2182, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2183, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2184, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2185, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2186, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2187, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2188, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2189, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2190, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2191, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2192, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2193, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2194, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2195, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2196, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2197, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2198, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2199, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2200, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2201, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2202, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2203, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2204, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2205, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2206, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2207, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2208, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2209, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2210, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2211, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2212, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2213, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2214, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2215, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2216, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2217, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2218, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2219, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2220, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2221, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2222, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2223, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2224, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2225, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2226, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2227, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2228, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2229, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2230, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2231, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2232, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2233, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2234, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2235, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2236, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2237, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2238, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2239, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2240, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2241, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2242, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2243, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2244, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2245, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2246, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2247, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2248, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2249, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2250, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2251, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2252, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2253, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2254, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2255, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2256, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2257, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2258, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2259, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2260, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2261, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2262, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2263, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2264, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2265, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2266, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2267, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2268, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2269, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2270, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2271, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2272, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2273, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2274, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2275, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2276, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2277, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2278, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2279, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2280, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2281, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2282, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2283, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2284, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2285, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2286, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2287, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2288, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2289, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2290, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2291, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2292, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2293, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2294, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2295, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2296, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2297, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2298, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2299, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2300, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2301, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2302, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2303, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2304, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2305, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2306, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2307, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2308, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2309, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2310, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2311, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2312, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2313, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2314, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2315, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2316, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2317, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2318, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2319, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2320, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2321, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2322, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2323, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2324, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2325, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2326, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2327, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2328, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2329, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2330, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2331, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2332, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2333, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2334, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2335, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2336, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2337, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2338, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2339, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2340, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2341, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2342, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2343, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2344, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2345, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2346, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2347, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2348, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2349, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2350, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2351, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2352, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2353, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2354, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2355, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2356, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2357, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2358, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2359, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2360, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2361, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2362, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2363, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2364, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2365, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2366, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2367, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2368, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2369, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2370, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2371, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2372, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2373, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2374, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2375, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2376, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2377, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2378, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2379, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2380, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2381, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2382, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2383, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2384, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2385, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2386, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2387, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2388, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2389, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2390, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2391, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2392, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2393, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2394, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2395, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2396, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2397, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2398, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2399, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2400, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2401, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2402, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2403, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2404, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2405, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2406, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2407, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2408, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2409, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2410, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2411, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2412, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2413, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2414, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2415, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2416, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2417, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2418, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2419, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2420, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2421, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2422, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2423, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2424, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2425, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2426, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2427, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2428, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2429, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2430, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2431, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2432, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2433, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2434, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2435, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2436, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2437, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2438, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2439, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2440, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2441, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2442, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2443, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2444, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2445, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2446, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2447, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2448, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2449, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2450, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2451, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2452, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2453, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2454, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2455, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2456, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2457, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2458, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2459, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2460, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2461, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2462, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2463, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2464, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2465, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2466, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2467, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2468, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2469, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2470, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2471, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2472, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2473, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2474, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2475, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2476, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2477, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2478, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2479, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2480, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2481, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2482, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2483, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2484, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2485, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2486, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2487, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2488, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2489, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2490, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2491, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2492, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2493, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2494, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2495, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2496, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2497, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2498, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2499, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2500, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2501, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2502, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2503, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2504, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2505, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2506, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2507, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2508, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2509, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2510, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2511, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2512, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2513, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2514, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2515, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2516, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2517, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2518, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2519, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2520, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2521, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2522, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2523, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2524, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2525, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2526, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2527, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2528, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2529, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2530, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2531, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2532, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2533, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2534, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2535, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2536, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2537, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2538, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2539, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2540, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2541, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2542, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2543, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2544, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2545, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2546, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2547, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2548, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2549, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2550, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2551, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2552, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2553, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2554, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2555, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2556, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2557, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2558, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2559, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2560, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2561, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2562, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2563, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2564, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2565, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2566, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2567, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2568, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2569, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2570, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2571, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2572, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2573, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2574, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2575, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2576, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2577, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2578, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2579, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2580, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2581, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2582, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2583, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2584, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2585, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2586, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2587, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2588, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2589, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2590, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2591, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2592, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2593, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2594, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2595, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2596, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2597, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2598, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2599, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2600, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2601, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2602, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2603, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2604, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2605, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2606, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2607, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2608, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2609, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2610, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2611, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2612, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2613, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2614, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2615, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2616, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2617, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2618, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2619, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2620, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2621, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2622, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2623, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2624, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2625, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2626, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2627, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2628, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2629, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2630, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2631, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2632, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2633, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2634, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2635, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2636, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2637, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2638, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2639, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2640, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2641, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2642, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2643, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2644, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2645, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2646, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2647, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2648, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2649, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2650, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2651, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2652, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2653, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2654, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2655, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2656, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2657, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2658, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2659, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2660, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2661, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2662, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2663, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2664, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2665, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2666, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2667, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2668, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2669, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2670, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2671, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2672, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2673, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2674, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2675, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2676, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2677, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2678, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2679, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2680, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2681, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2682, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2683, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2684, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2685, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2686, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2687, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2688, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2689, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2690, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2691, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2692, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2693, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2694, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2695, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2696, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2697, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2698, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2699, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2700, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2701, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2702, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2703, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2704, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2705, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2706, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2707, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2708, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2709, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2710, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2711, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2712, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2713, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2714, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2715, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2716, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2717, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2718, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2719, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2720, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2721, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2722, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2723, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2724, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2725, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2726, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2727, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2728, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2729, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2730, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2731, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2732, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2733, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2734, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2735, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2736, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2737, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2738, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2739, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2740, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2741, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2742, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2743, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2744, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2745, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2746, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2747, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2748, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2749, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2750, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2751, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2752, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2753, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2754, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2755, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2756, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2757, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2758, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2759, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2760, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2761, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2762, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2763, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2764, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2765, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2766, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2767, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2768, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2769, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2770, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2771, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2772, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2773, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2774, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2775, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2776, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2777, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2778, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2779, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2780, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2781, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2782, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2783, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2784, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2785, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2786, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2787, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2788, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2789, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2790, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2791, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2792, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2793, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2794, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2795, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2796, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2797, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2798, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2799, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2800, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2801, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2802, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2803, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2804, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2805, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2806, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2807, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2808, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2809, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2810, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2811, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2812, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2813, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2814, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2815, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2816, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2817, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2818, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2819, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2820, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2821, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2822, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2823, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2824, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2825, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2826, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2827, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2828, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2829, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2830, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2831, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2832, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2833, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2834, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2835, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2836, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2837, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2838, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2839, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2840, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2841, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2842, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2843, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2844, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2845, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2846, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2847, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2848, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2849, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2850, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2851, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2852, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2853, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2854, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2855, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2856, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2857, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2858, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2859, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2860, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2861, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2862, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2863, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2864, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2865, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2866, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2867, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2868, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2869, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2870, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2871, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2872, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2873, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2874, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2875, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2876, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2877, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2878, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2879, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2880, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2881, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2882, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2883, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2884, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2885, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2886, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2887, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2888, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2889, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2890, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2891, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2892, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2893, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2894, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2895, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2896, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2897, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2898, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2899, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2900, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2901, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2902, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2903, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2904, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2905, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2906, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2907, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2908, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2909, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2910, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2911, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2912, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2913, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2914, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2915, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2916, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2917, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2918, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2919, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2920, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2921, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2922, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2923, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2924, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2925, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2926, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2927, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2928, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2929, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2930, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2931, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2932, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2933, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2934, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2935, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2936, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2937, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2938, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2939, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2940, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2941, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2942, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2943, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2944, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2945, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2946, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2947, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2948, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2949, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2950, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2951, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2952, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2953, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2954, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2955, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2956, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2957, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2958, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2959, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2960, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2961, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2962, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2963, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2964, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2965, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2966, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2967, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2968, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2969, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2970, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2971, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2972, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2973, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2974, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2975, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2976, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2977, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2978, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2979, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2980, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2981, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2982, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2983, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2984, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2985, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2986, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2987, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2988, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2989, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2990, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2991, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2992, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2993, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2994, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2995, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2996, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2997, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2998, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 2999, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3000, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3001, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3002, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3003, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3004, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3005, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3006, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3007, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3008, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3009, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3010, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3011, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3012, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3013, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3014, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3015, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3016, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3017, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3018, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3019, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3020, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3021, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3022, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3023, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3024, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3025, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3026, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3027, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3028, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3029, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3030, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3031, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3032, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3033, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3034, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3035, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3036, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3037, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3038, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3039, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3040, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3041, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3042, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3043, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3044, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3045, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3046, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3047, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3048, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3049, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3050, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3051, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3052, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3053, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3054, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3055, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3056, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3057, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3058, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3059, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3060, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3061, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3062, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3063, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3064, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3065, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3066, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3067, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3068, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3069, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3070, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3071, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3072, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3073, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3074, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3075, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3076, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3077, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3078, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3079, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3080, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3081, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3082, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3083, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3084, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3085, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3086, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3087, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3088, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3089, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3090, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3091, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3092, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3093, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3094, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3095, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3096, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3097, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3098, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3099, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3100, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3101, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3102, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3103, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3104, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3105, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3106, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3107, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3108, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3109, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3110, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3111, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3112, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3113, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3114, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3115, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3116, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3117, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3118, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3119, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3120, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3121, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3122, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3123, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3124, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3125, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3126, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3127, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3128, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3129, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3130, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3131, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3132, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3133, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3134, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3135, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3136, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3137, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3138, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3139, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3140, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3141, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3142, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3143, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3144, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3145, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3146, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3147, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3148, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3149, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3150, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3151, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3152, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3153, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3154, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3155, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3156, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3157, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3158, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3159, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3160, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3161, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3162, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3163, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3164, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3165, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3166, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3167, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3168, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3169, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3170, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3171, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3172, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3173, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3174, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3175, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3176, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3177, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3178, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3179, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3180, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3181, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3182, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3183, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3184, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3185, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3186, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3187, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3188, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3189, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3190, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3191, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3192, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3193, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3194, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3195, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3196, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3197, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3198, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3199, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3200, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3201, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3202, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3203, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3204, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3205, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3206, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3207, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3208, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3209, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3210, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3211, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3212, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3213, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3214, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3215, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3216, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3217, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3218, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3219, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3220, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3221, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3222, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3223, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3224, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3225, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3226, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3227, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3228, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3229, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3230, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3231, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3232, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3233, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3234, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3235, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3236, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3237, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3238, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3239, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3240, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3241, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3242, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3243, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3244, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3245, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3246, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3247, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3248, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3249, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3250, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3251, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3252, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3253, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3254, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3255, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3256, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3257, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3258, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3259, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3260, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3261, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3262, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3263, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3264, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3265, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3266, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3267, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3268, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3269, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3270, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3271, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3272, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3273, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3274, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3275, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3276, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3277, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3278, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3279, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3280, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3281, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3282, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3283, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3284, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3285, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3286, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3287, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3288, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3289, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3290, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3291, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3292, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3293, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3294, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3295, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3296, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3297, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3298, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3299, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3300, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3301, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3302, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3303, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3304, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3305, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3306, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3307, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3308, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3309, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3310, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3311, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3312, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3313, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3314, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3315, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3316, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3317, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3318, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3319, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3320, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3321, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3322, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3323, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3324, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3325, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3326, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3327, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3328, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3329, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3330, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3331, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3332, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3333, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3334, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3335, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3336, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3337, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3338, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3339, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3340, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3341, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3342, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3343, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3344, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3345, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3346, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3347, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3348, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3349, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3350, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3351, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3352, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3353, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3354, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3355, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3356, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3357, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3358, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3359, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3360, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3361, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3362, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3363, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3364, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3365, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3366, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3367, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3368, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3369, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3370, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3371, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3372, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3373, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3374, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3375, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3376, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3377, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3378, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3379, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3380, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3381, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3382, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3383, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3384, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3385, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3386, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3387, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3388, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3389, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3390, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3391, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3392, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3393, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3394, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3395, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3396, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3397, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3398, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3399, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3400, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3401, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3402, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3403, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3404, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3405, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3406, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3407, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3408, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3409, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3410, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3411, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3412, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3413, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3414, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3415, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3416, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3417, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3418, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3419, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3420, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3421, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3422, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3423, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3424, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3425, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3426, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3427, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3428, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3429, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3430, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3431, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3432, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3433, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3434, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3435, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3436, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3437, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3438, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3439, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3440, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3441, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3442, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3443, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3444, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3445, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3446, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3447, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3448, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3449, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3450, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3451, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3452, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3453, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3454, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3455, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3456, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3457, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3458, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3459, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3460, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3461, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3462, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3463, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3464, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3465, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3466, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3467, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3468, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3469, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3470, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3471, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3472, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3473, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3474, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3475, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3476, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3477, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3478, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3479, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3480, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3481, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3482, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3483, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3484, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3485, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3486, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3487, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3488, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3489, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3490, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3491, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3492, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3493, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3494, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3495, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3496, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3497, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3498, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3499, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3500, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3501, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3502, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3503, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3504, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3505, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3506, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3507, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3508, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3509, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3510, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3511, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3512, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3513, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3514, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3515, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3516, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3517, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3518, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3519, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3520, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3521, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3522, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3523, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3524, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3525, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3526, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3527, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3528, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3529, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3530, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3531, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3532, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3533, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3534, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3535, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3536, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3537, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3538, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3539, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3540, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3541, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3542, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3543, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3544, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3545, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3546, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3547, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3548, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3549, -1);
INSERT INTO scholarship (user_id_scholarship_php, scholarship_id_php, user_id_scholarship_rest) VALUES (3, 3550, -1);